import type { Client, Integration, IntegrationClass } from '@sentry/types';
import type { NodeClient } from '../../client';
import type { AnrIntegrationOptions } from './common';
export declare const anrIntegration: (options?: Partial<AnrIntegrationOptions> | undefined) => import("@sentry/types").IntegrationFnResult;
/**
 * Starts a thread to detect App Not Responding (ANR) events
 *
 * ANR detection requires Node 16.17.0 or later
 *
 * @deprecated Use `anrIntegration()` instead.
 */
export declare const Anr: IntegrationClass<Integration & {
    setup: (client: NodeClient) => void;
}> & (new (options?: Partial<AnrIntegrationOptions>) => Integration & {
    setup(client: Client): void;
});
export type Anr = typeof Anr;
//# sourceMappingURL=index.d.ts.map